// This file is generated by kconfig_compiler from kcalc.kcfg.
// All changes you do to this file will be lost.
#ifndef KCALCSETTINGS_H
#define KCALCSETTINGS_H

#include <kconfigskeleton.h>
#include <kdebug.h>

#include <KApplication>
#include <KGlobalSettings>
#include <KColorScheme>
class KCalcSettings : public KConfigSkeleton
{
  public:

    static KCalcSettings *self();
    ~KCalcSettings();

    /**
      Set The foreground color of the display.
    */
    static
    void setForeColor( const QColor & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "ForeColor" ) ))
        self()->mForeColor = v;
    }

    /**
      Get The foreground color of the display.
    */
    static
    QColor foreColor()
    {
      return self()->mForeColor;
    }

    /**
      Set The background color of the display.
    */
    static
    void setBackColor( const QColor & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "BackColor" ) ))
        self()->mBackColor = v;
    }

    /**
      Get The background color of the display.
    */
    static
    QColor backColor()
    {
      return self()->mBackColor;
    }

    /**
      Set The color of number buttons.
    */
    static
    void setNumberButtonsColor( const QColor & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "NumberButtonsColor" ) ))
        self()->mNumberButtonsColor = v;
    }

    /**
      Get The color of number buttons.
    */
    static
    QColor numberButtonsColor()
    {
      return self()->mNumberButtonsColor;
    }

    /**
      Set The color of function buttons.
    */
    static
    void setFunctionButtonsColor( const QColor & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "FunctionButtonsColor" ) ))
        self()->mFunctionButtonsColor = v;
    }

    /**
      Get The color of function buttons.
    */
    static
    QColor functionButtonsColor()
    {
      return self()->mFunctionButtonsColor;
    }

    /**
      Set The color of statistical buttons.
    */
    static
    void setStatButtonsColor( const QColor & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "StatButtonsColor" ) ))
        self()->mStatButtonsColor = v;
    }

    /**
      Get The color of statistical buttons.
    */
    static
    QColor statButtonsColor()
    {
      return self()->mStatButtonsColor;
    }

    /**
      Set The color of hex buttons.
    */
    static
    void setHexButtonsColor( const QColor & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "HexButtonsColor" ) ))
        self()->mHexButtonsColor = v;
    }

    /**
      Get The color of hex buttons.
    */
    static
    QColor hexButtonsColor()
    {
      return self()->mHexButtonsColor;
    }

    /**
      Set The color of memory buttons.
    */
    static
    void setMemoryButtonsColor( const QColor & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "MemoryButtonsColor" ) ))
        self()->mMemoryButtonsColor = v;
    }

    /**
      Get The color of memory buttons.
    */
    static
    QColor memoryButtonsColor()
    {
      return self()->mMemoryButtonsColor;
    }

    /**
      Set The color of operation buttons.
    */
    static
    void setOperationButtonsColor( const QColor & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "OperationButtonsColor" ) ))
        self()->mOperationButtonsColor = v;
    }

    /**
      Get The color of operation buttons.
    */
    static
    QColor operationButtonsColor()
    {
      return self()->mOperationButtonsColor;
    }

    /**
      Set The font to use for the buttons.
    */
    static
    void setButtonFont( const QFont & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "ButtonFont" ) ))
        self()->mButtonFont = v;
    }

    /**
      Get The font to use for the buttons.
    */
    static
    QFont buttonFont()
    {
      return self()->mButtonFont;
    }

    /**
      Set The font to use in the display.
    */
    static
    void setDisplayFont( const QFont & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "DisplayFont" ) ))
        self()->mDisplayFont = v;
    }

    /**
      Get The font to use in the display.
    */
    static
    QFont displayFont()
    {
      return self()->mDisplayFont;
    }

    /**
      Set Maximum number of digits displayed.
    */
    static
    void setPrecision( uint v )
    {
      if (v < 8)
      {
        kDebug() << "setPrecision: value " << v << " is less than the minimum value of 8" << endl;
        v = 8;
      }

      if (v > 200)
      {
        kDebug() << "setPrecision: value " << v << " is greater than the maximum value of 200" << endl;
        v = 200;
      }

      if (!self()->isImmutable( QString::fromLatin1 ( "Precision" ) ))
        self()->mPrecision = v;
    }

    /**
      Get Maximum number of digits displayed.
    */
    static
    uint precision()
    {
      return self()->mPrecision;
    }

    /**
      Set Number of fixed decimal digits.
    */
    static
    void setFixedPrecision( uint v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "FixedPrecision" ) ))
        self()->mFixedPrecision = v;
    }

    /**
      Get Number of fixed decimal digits.
    */
    static
    uint fixedPrecision()
    {
      return self()->mFixedPrecision;
    }

    /**
      Set Whether to use fixed decimal places.
    */
    static
    void setFixed( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "Fixed" ) ))
        self()->mFixed = v;
    }

    /**
      Get Whether to use fixed decimal places.
    */
    static
    bool fixed()
    {
      return self()->mFixed;
    }

    /**
      Set Whether to beep on error.
    */
    static
    void setBeep( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "Beep" ) ))
        self()->mBeep = v;
    }

    /**
      Get Whether to beep on error.
    */
    static
    bool beep()
    {
      return self()->mBeep;
    }

    /**
      Set Whether to show the result in the window title.
    */
    static
    void setCaptionResult( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "CaptionResult" ) ))
        self()->mCaptionResult = v;
    }

    /**
      Get Whether to show the result in the window title.
    */
    static
    bool captionResult()
    {
      return self()->mCaptionResult;
    }

    /**
      Set Whether to group digits.
    */
    static
    void setGroupDigits( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "GroupDigits" ) ))
        self()->mGroupDigits = v;
    }

    /**
      Get Whether to group digits.
    */
    static
    bool groupDigits()
    {
      return self()->mGroupDigits;
    }

    /**
      Set Whether to use Two's Complement for non-decimal numbers.
    */
    static
    void setTwosComplement( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "TwosComplement" ) ))
        self()->mTwosComplement = v;
    }

    /**
      Get Whether to use Two's Complement for non-decimal numbers.
    */
    static
    bool twosComplement()
    {
      return self()->mTwosComplement;
    }

    /**
      Set Whether to show the bit edit widget.
    */
    static
    void setShowBitset( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "ShowBitset" ) ))
        self()->mShowBitset = v;
    }

    /**
      Get Whether to show the bit edit widget.
    */
    static
    bool showBitset()
    {
      return self()->mShowBitset;
    }

    /**
      Set Whether to show statistical buttons.
    */
    static
    void setShowStat( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "ShowStat" ) ))
        self()->mShowStat = v;
    }

    /**
      Get Whether to show statistical buttons.
    */
    static
    bool showStat()
    {
      return self()->mShowStat;
    }

    /**
      Set Whether to show buttons with functions used in science/engineering,
	     like exp, log, sin etc.
    */
    static
    void setShowScientific( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "ShowScientific" ) ))
        self()->mShowScientific = v;
    }

    /**
      Get Whether to show buttons with functions used in science/engineering,
	     like exp, log, sin etc.
    */
    static
    bool showScientific()
    {
      return self()->mShowScientific;
    }

    /**
      Set Whether to show logic buttons.
    */
    static
    void setShowLogic( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "ShowLogic" ) ))
        self()->mShowLogic = v;
    }

    /**
      Get Whether to show logic buttons.
    */
    static
    bool showLogic()
    {
      return self()->mShowLogic;
    }

    /**
      Set Whether to show constant buttons.
    */
    static
    void setShowConstants( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "ShowConstants" ) ))
        self()->mShowConstants = v;
    }

    /**
      Get Whether to show constant buttons.
    */
    static
    bool showConstants()
    {
      return self()->mShowConstants;
    }

    /**
      Set Degrees, radians or grads
    */
    static
    void setAngleMode( uint v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "AngleMode" ) ))
        self()->mAngleMode = v;
    }

    /**
      Get Degrees, radians or grads
    */
    static
    uint angleMode()
    {
      return self()->mAngleMode;
    }

    /**
      Set Numeric base
    */
    static
    void setBaseMode( uint v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "BaseMode" ) ))
        self()->mBaseMode = v;
    }

    /**
      Get Numeric base
    */
    static
    uint baseMode()
    {
      return self()->mBaseMode;
    }

    /**
      Set Name of the user programmable constants.
    */
    static
    void setNameConstant( int i, const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "nameConstant%1" ).arg( i ) ))
        self()->mNameConstant[i] = v;
    }

    /**
      Get Name of the user programmable constants.
    */
    static
    QString nameConstant( int i )
    {
      return self()->mNameConstant[i];
    }

    /**
      Set List of user programmable constants
    */
    static
    void setValueConstant( int i, const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "valueConstant%1" ).arg( i ) ))
        self()->mValueConstant[i] = v;
    }

    /**
      Get List of user programmable constants
    */
    static
    QString valueConstant( int i )
    {
      return self()->mValueConstant[i];
    }

  protected:
    KCalcSettings();
    friend class KCalcSettingsHelper;


    // Colors
    QColor mForeColor;
    QColor mBackColor;
    QColor mNumberButtonsColor;
    QColor mFunctionButtonsColor;
    QColor mStatButtonsColor;
    QColor mHexButtonsColor;
    QColor mMemoryButtonsColor;
    QColor mOperationButtonsColor;

    // Font
    QFont mButtonFont;
    QFont mDisplayFont;

    // Precision
    uint mPrecision;
    uint mFixedPrecision;
    bool mFixed;

    // General
    bool mBeep;
    bool mCaptionResult;
    bool mGroupDigits;
    bool mTwosComplement;
    bool mShowBitset;
    bool mShowStat;
    bool mShowScientific;
    bool mShowLogic;
    bool mShowConstants;
    uint mAngleMode;
    uint mBaseMode;

    // UserConstants
    QString mNameConstant[6];
    QString mValueConstant[6];

  private:
};

#endif

